---
- name: Check/create portgroup
  vmware_dvs_portgroup:
    hostname: "{{ vault_spec.data.VCHostname }}"
    username: "{{ vault_spec.data.VCUsername }}"
    password: "{{ vault_spec.data.VCPassword }}"
    portgroup_name: "{{ uplink_pg_name }}"
    switch_name: "{{ uplink_switch_name }}"
    vlan_id: "{{ uplink_pg_vlan }}"
    num_ports: 16
    portgroup_type: earlyBinding
    state: present
    validate_certs: False
  register: portgroup_spec
  tags: [ 'esg' ]

- name: Gather moid for datastore
  vcenter_gather_moids:
    hostname: "{{ vault_spec.data.VCHostname }}"
    username: "{{ vault_spec.data.VCUsername }}"
    password: "{{ vault_spec.data.VCPassword }}"
    datacenter_name: "{{ datacenter }}"
    datastore_name: "{{ datastore }}"
    validate_certs: False
  register: gather_moids_ds
  tags: [ 'esg' ]

- name: Gather moid for cluster
  vcenter_gather_moids:
    hostname: "{{ vault_spec.data.VCHostname }}"
    username: "{{ vault_spec.data.VCUsername }}"
    password: "{{ vault_spec.data.VCPassword }}"
    datacenter_name: "{{ datacenter }}"
    cluster_name: "{{ cluster }}"
    validate_certs: False
  register: gather_moids_cl
  tags: [ 'esg' ]

- name: Gather moid for uplink
  vcenter_gather_moids:
    hostname: "{{ vault_spec.data.VCHostname }}"
    username: "{{ vault_spec.data.VCUsername }}"
    password: "{{ vault_spec.data.VCPassword }}"
    datacenter_name: "{{ datacenter }}"
    portgroup_name: "{{ uplink_pg_name }}"
    validate_certs: False
  register: gather_moids_upl_pg
  tags: [ 'esg' ]

- name: Check/create Logical switch
  nsx_logical_switch:
    nsxmanager_spec: "{{ vault_spec.data.nsxmanager_spec }}"
    state: present
    transportzone: "{{ ls_transportzone }}"
    name: "{{ downlink_ls_name }}"
    controlplanemode: "{{ downlink_ls_controlplanemode }}"
    description: "{{ downlink_ls_description }}"
  register: create_logical_switch
  tags: [ 'esg' ]


  # for the vnic definitions, typically use portgroup_id for uplink and logical_switch name for the downlink..
- name: Create the ESG
  nsx_edge_router:
    nsxmanager_spec: "{{ vault_spec.data.nsxmanager_spec }}"
    state: present
    name: "{{ name }}"
    description: "{{ description }}"
    resourcepool_moid: "{{ gather_moids_cl.object_id }}"
    datastore_moid: "{{ gather_moids_ds.object_id }}"
    datacenter_moid: "{{ gather_moids_cl.datacenter_moid }}"
    interfaces:
      vnic0: {ip: "{{ vnic0['ip'] }}", prefix_len: "{{ vnic0['prefix_len'] }}", portgroup_id: "{{ gather_moids_upl_pg.object_id }}", name: "{{ vnic0['name'] }}", iftype: "{{ vnic0['iftype'] }}", fence_param: 'ethernet0.filter1.param1=1'}
      vnic1: {ip: "{{ vnic1['ip'] }}", prefix_len: "{{ vnic1['prefix_len'] }}", logical_switch: "{{ downlink_ls_name }}", name: "{{ vnic1['name'] }}", iftype: "{{ vnic1['iftype'] }}", fence_param: 'ethernet0.filter1.param1=1'}
    remote_access: "{{ remote_access }}"
    username: "{{ username }}"
    password: "{{ password }}"
    firewall: "{{ firewall }}"
    ha_enabled: "{{ ha_enabled }}"
  register: create_esg
  tags: [ 'esg' ]
  no_log: true
